unit danu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  inifiles,shellapi,StdCtrls, ExtCtrls, Grids, SortGrid,
  registry,comctrls,spin;


//----------------------------------------------------------------------------
procedure dan_curh;
procedure dan_curd;
procedure dan_curah;
procedure dan_curad;
//----------------------------------------------------------------------------
procedure dan_msgfehler(s:string);
procedure dan_msghinweis(s:string);
function dan_msgfrage(s:string;cancel:bool):integer;
function dan_getinput(titel,info,def:string):string;
procedure dan_wrstatus(p:tpanel;s:string);
//----------------------------------------------------------------------------
function dan_add2lb(var lb:tlistbox;s:string;doubleok:bool;var status:string):integer;
function dan_dellb(var lb:tlistbox;row:integer;var status:string):integer;
function dan_inlb(lb:tlistbox;s:string;mode:integer):integer;
function dan_getlbsel(lb:tlistbox):integer;
//----------------------------------------------------------------------------
function dan_gethomedir:string;
function dan_getinifn:string;
procedure dan_rdfrmini(var frm:tform;fn:string;var status:string);
procedure dan_wrfrmini(frm:tform;fn:string;var status:string);
function dan_space2ini(s:string):string;
function dan_ini2space(s:string):string;
//----------------------------------------------------------------------------
function  dan_GetShortName(sLongName:string):string;
procedure dan_sleep(zeit:dword);
function dan_startprg(fn,param:string;var status:string):longint;

//----------------------------------------------------------------------------
procedure dan_sgdesign(sg:tsortgrid);
procedure dan_sgsort(sg:tsortgrid;col:integer;down:bool);
function dan_sgincol(sg:tsortgrid;s:string;col:integer):integer;
//----------------------------------------------------------------------------
//function dan_soundex:bool;
//----------------------------------------------------------------------------
function dan_krypt(s:string;key:integer):string;
function dan_dekrypt(s:string;key:integer):string;
//----------------------------------------------------------------------------
procedure dan_token(srch:string;var s,token:string;casesensitiv:bool);
//----------------------------------------------------------------------------
function dan_prg(prg,param:string;var status:string):bool;
//----------------------------------------------------------------------------
function dan_regGetExeForExt(Ext:string):string;
function dan_regSetExeForExt(exename,extension:string):bool;
function dan_regKillExtForExe(extension,exename:string):bool;
//----------------------------------------------------------------------------


var
  cursortmp:tcursor;

//----------------------------------------------------------------------------

implementation

//----------------------------------------------------------------------------
procedure dan_curh;
begin
  cursortmp:=screen.cursor;
  screen.cursor:=crhourglass;
end;

procedure dan_curd;
begin
  screen.cursor:=cursortmp;
end;

procedure dan_curah;
begin
  screen.cursor:=crhourglass;
end;

procedure dan_curad;
begin
  screen.cursor:=crdefault;
end;

//----------------------------------------------------------------------------
procedure dan_msgfehler(s:string);
begin
  beep;
  application.messagebox(pchar(s),'*** FEHLER ***',mb_ok);
end;

procedure dan_msghinweis(s:string);
begin
  application.messagebox(pchar(s),'*** HINWEIS ***',mb_ok);
end;

function dan_msgfrage(s:string;cancel:bool):integer;
begin
  if cancel then begin
    result:=application.messagebox(pchar(s),'*** FRAGE ***',mb_yesnocancel);
  end
  else begin
    result:=application.messagebox(pchar(s),'*** FRAGE ***',mb_yesno);
  end;
end;

function dan_getinput(titel,info,def:string):string;
var
  s:string;
begin
  s:=def;
  if Inputquery(titel,info,s) then
    result:=s
  else
    result:='';
end;

procedure dan_wrstatus(p:tpanel;s:string);
begin
  p.caption:=' '+datetimetostr(now)+': '+s;
  p.update;
end;

//--------------------------------------------------------------------------

function dan_add2lb(var lb:tlistbox;s:string;doubleok:bool;var status:string):integer;
var
  r:integer;
  us,ss:string;
  found:bool;
begin
  if not doubleok then begin
    found:=false;
    us:=ansilowercase(s);
    for r:=0 to lb.items.count-1 do begin
      ss:=ansilowercase(lb.items[r]);
      if ss=us then begin
        found:=true;
        break;
      end;
    end;
    if found then begin
      status:='Eintrag "'+s+'" bereits vorhanden.';
      result:=-1;
      exit;
    end;
  end;
  status:='Eintrag "'+s+'" hinzugefgt.';
  result:=lb.items.add(s);
end;

//row=-1, dann selected suchen
function dan_dellb(var lb:tlistbox;row:integer;var status:string):integer;
var
  r:integer;
begin
  if row=-1 then begin
    for r:=0 to lb.items.count-1 do begin
      if lb.selected[r] then begin
        row:=r;
        break;
      end;
    end;
  end;
  if (row>-1)and(row<lb.items.count) then begin
    status:='Eintrag "'+lb.items[row]+'" gelscht.';
    lb.items.delete(row);
  end
  else begin
    status:='Eintragsnummer "'+inttostr(row)+'" nicht gefunden.';
  end;
  result:=row;
end;

function dan_getlbsel(lb:tlistbox):integer;
var
  r:integer;
begin
  result:=-1;
  for r:=0 to lb.items.count-1 do begin
    if lb.selected[r] then begin
      result:=r;
      break;
    end;
  end;
end;

//mode: 0=exact, 1=pos(lb,s), 2=pos(s,lb);
function dan_inlb(lb:tlistbox;s:string;mode:integer):integer;
var
  r:integer;
  ss,us:string;
begin
  result:=-1;
  us:=ansilowercase(s);
  for r:=0 to lb.items.count-1 do begin
    ss:=ansilowercase(lb.items[r]);
    if (mode=0)and(us=ss) then begin
      result:=r;
      break;
    end
    else if (mode=1)and(pos(ss,us)>0) then begin
      result:=r;
      break;
    end
    else if (mode=2)and(pos(us,ss)>0) then begin
      result:=r;
      break;
    end;
  end;
end;

//--------------------------------------------------------------------------
function dan_gethomedir:string;
begin
  result:=extractfilepath(application.exename);
end;

function dan_getinifn:string;
begin
  result:=extractfilename(application.exename);
  result:=extractfilepath(application.exename)+copy(result,1,length(result)-3)+'ini';
end;

function dan_ini2space(s:string):string;
begin
  result:=trim(s);if length(s)<2 then exit;
  if(s[1]='{')and(s[length(s)]='}') then begin
    result:=copy(s,2,length(s)-2);
  end;
end;

function dan_space2ini(s:string):string;
begin
  result:=s;if(length(s)=0)or(trim(s)<>'')then exit;
  result:='{'+s+'}';
end;

//combobox:tag=1 nur text, 2=alles
procedure dan_rdfrmini(var frm:tform;fn:string;var status:string);
var
  inif:tinifile;
  s,frmname:string;
  c,r,rr,rows,cols:integer;
  co:tcomponent;
begin
  dan_curh;
  inif:=tinifile.create(fn);
  frmname:=frm.name;
  for r:=0 to frm.componentcount-1 do begin
    co:=frm.components[r];
    if co.tag>0 then begin
      if co is tedit then
        tedit(co).text:=dan_ini2space(inif.readstring(frmname,co.name,tedit(co).text))
      else if co is tspinedit then
        tspinedit(co).value:=inif.readinteger(frmname,co.name,tspinedit(co).value)
      else if co is tcheckbox then
        tcheckbox(co).checked:=inif.readbool(frmname,co.name,tcheckbox(co).checked)
      else if co is tradiobutton then
        tradiobutton(co).checked:=inif.readbool(frmname,co.name,tradiobutton(co).checked)
      else if co is tlistbox then begin
        tlistbox(co).clear;
        rr:=0;
        repeat
          s:=dan_ini2space(inif.readstring(frmname,co.name+'_'+inttostr(rr),''));
          if s<>'' then
            tlistbox(co).items.add(s);
          rr:=rr+1;
        until s='';
      end
      else if co is tmemo then begin
        tmemo(co).clear;
        rr:=0;
        repeat
          s:=dan_ini2space(inif.readstring(frmname,co.name+'_'+inttostr(rr),''));
          if s<>'' then begin
            if s='__leer__' then s:=' ';
            tmemo(co).lines.add(s);
          end;
          rr:=rr+1;
        until s='';
      end
      else if co is tsortgrid then begin
        rows:=inif.readinteger(frmname,co.name+'_rows',tsortgrid(co).rowcount);
        cols:=inif.readinteger(frmname,co.name+'_cols',tsortgrid(co).colcount);
        tsortgrid(co).rowcount:=rows;
        tsortgrid(co).colcount:=cols;
        tsortgrid(co).Clear(true);
        for rr:=0 to rows-1 do begin
          for c:=0 to cols-1 do begin
            tsortgrid(co).cells[c,rr]:=dan_ini2space(
              inif.readstring(frmname,co.name+'_'+inttostr(c)+'_'+inttostr(rr),'')
            );
          end;
        end;
      end
      else if co is tcombobox then begin
        if tcombobox(co).style=csDropDownList then begin
          if co.tag=2 then begin
            tcombobox(co).clear;
            rr:=0;
            repeat
              s:=dan_ini2space(inif.readstring(frmname,co.name+'_'+inttostr(rr),''));
              if s<>'' then
                tcombobox(co).items.add(s);
              rr:=rr+1;
            until s='';
          end;
          tcombobox(co).itemindex:=inif.readinteger(frmname,co.name,0);
        end
        else begin
          if co.tag=2 then begin
            tcombobox(co).clear;
            rr:=0;
            repeat
              s:=dan_ini2space(inif.readstring(frmname,co.name+'_'+inttostr(rr),''));
              if s<>'' then
                tcombobox(co).items.add(s);
              rr:=rr+1;
            until s='';
          end;
          tcombobox(co).text:=dan_ini2space(inif.readstring(frmname,co.name,tcombobox(co).text));
        end;
      end;
    end;
  end;
  inif.free;
  status:='INI-Datei "'+fn+'" gelesen.';
  dan_curd;
end;

procedure dan_wrfrmini(frm:tform;fn:string;var status:string);
var
  inif:tinifile;
  frmname:string;
  c,r,rr:integer;
  co:tcomponent;
begin
  dan_curh;
  inif:=tinifile.create(fn);
  frmname:=frm.name;
  inif.erasesection(frmname);
  for r:=0 to frm.componentcount-1 do begin
    co:=frm.components[r];
    if co.tag>0 then begin
      if co is tedit then
        inif.writestring(frmname,co.name,dan_space2ini(tedit(co).text))
      else if co is tspinedit then
        inif.writeinteger(frmname,co.name,tspinedit(co).value)
      else if co is tcheckbox then
        inif.writebool(frmname,co.name,tcheckbox(co).checked)
      else if co is tradiobutton then
        inif.writebool(frmname,co.name,tradiobutton(co).checked)
      else if co is tlistbox then begin
        for rr:=0 to tlistbox(co).items.count-1 do begin
          inif.writestring(frmname,co.name+'_'+inttostr(rr),dan_space2ini(tlistbox(co).items[rr]))
        end;
      end
      else if co is tsortgrid then begin
        inif.writeinteger(frmname,co.name+'_rows',tsortgrid(co).rowcount);
        inif.writeinteger(frmname,co.name+'_cols',tsortgrid(co).colcount);
        for rr:=0 to tsortgrid(co).rowcount-1 do begin
          for c:=0 to tsortgrid(co).colcount-1 do begin
            inif.writestring(frmname,co.name+'_'+inttostr(c)+'_'+inttostr(rr),
              dan_space2ini(tsortgrid(co).cells[c,rr])
            );
          end;
        end;
      end
      else if co is tmemo then begin
        for rr:=0 to tmemo(co).lines.count-1 do begin
          if trim(tmemo(co).lines[rr])='' then
            inif.writestring(frmname,co.name+'_'+inttostr(rr),'__leer__')
          else
            inif.writestring(frmname,co.name+'_'+inttostr(rr),dan_space2ini(tmemo(co).lines[rr]));
        end;
      end
      else if co is tcombobox then begin
        if tcombobox(co).style=csDropDownList then
          inif.writeinteger(frmname,co.name,tcombobox(co).itemindex)
        else
          inif.writestring(frmname,co.name,dan_space2ini(tcombobox(co).text));
        if co.tag=2 then begin
          for rr:=0 to tcombobox(co).items.count-1 do begin
            inif.writestring(frmname,co.name+'_'+inttostr(rr),dan_space2ini(tcombobox(co).items[rr]))
          end;
        end;
      end
    end;
  end;
  inif.free;
  status:='INI-Datei "'+fn+'" geschrieben.';
  dan_curd;
end;

//--------------------------------------------------------------------------

function  dan_GetShortName(sLongName:string):string;
var
  sShortName:string;
  nShortNameLen:integer;
begin
  SetLength(sShortName,MAX_PATH);
  nShortNameLen :=
    GetShortPathName(
      PChar(sLongName),
      PChar(sShortName),
      MAX_PATH-1);
  if(nShortNameLen=0)then begin
    result:='fehler';
    exit;
  end;
  SetLength(sShortName,nShortNameLen);
  Result:=sShortName;
end;

procedure dan_sleep(zeit:dword);
var
  zeit1:dword;
begin
  zeit1:=gettickcount;
  repeat
    application.processmessages;
  until (gettickcount-zeit1)>zeit;
end;

function dan_startprg(fn,param:string;var status:string):longint;
var
  s:string;
begin
  result:=ShellExecute(application.Handle,NIL,PChar(fn),pchar(param),pchar(extractfilepath(s)),SW_SHOWNORMAL);
  if result>32 then
    status:='"'+fn+'" aufgerufen'
  else
    status:='ShellAPI-Fehler (#'+inttostr(result)+') bei Aufruf von "'+fn+'"';
end;

//--------------------------------------------------------------------------

procedure dan_sgdesign(sg:tsortgrid);
var
  c:integer;
begin
  for c:=0 to sg.colcount-1 do
    sg.AutoSizeCol(c);
end;

procedure dan_sgsort(sg:tsortgrid;col:integer;down:bool);
var
  so:tsortoptions;
begin
  so.SortStyle:=ssautomatic;
  if down then
    so.SortDirection:=sddescending
  else
    so.SortDirection:=sdascending;
  so.SortCaseSensitive:=false;
  sg.SortByColumn(col,so);
end;

function dan_sgincol(sg:tsortgrid;s:string;col:integer):integer;
var
  r:integer;
begin
  result:=-1;
  s:=ansiuppercase(s);
  for r:=0 to sg.rowcount-1 do begin
    if s=ansiuppercase(sg.cells[col,r]) then begin
      result:=r;
      break;
    end;
  end;
end;

//--------------------------------------------------------------------------
{
function dan_soundex:bool;
begin
  result:=waveoutgetnumdevs>0;
end;
}

//--------------------------------------------------------------------------
//0<key<50176
function dan_krypt(s:string;key:integer):string;
const
  B=224; //Ascii ohne Steuerzeichen
  BB=B*B; //Berechnet schon der Compiler
var
  k:integer;

  function fPlusNmodBB(x,n:integer):integer;
    //Hier knnte auch eine beliebige umkehrbare Funktion
    //mit dem Definitionsbereich {0,1,2,...,BB-1} stehen
    //z.B. der RSA-Algorithmus x->x^n mod BB
    //     die Umkehrfunktion ist dann aber nicht mehr mit -n zu bewerkstelligen
    //     sondern nur wenn die Zerlegung A=P1*P2 einer gewissen Zahl in
    //     ihre Primfaktoren P1 und P2 gelingt
  begin
    result:=x+n;
    if result>=BB then result:=result-BB;
    if result<0   then result:=result+BB;
  end;

  procedure VerschlZweierBlock(var c1,c2:char; n:integer);
  var i:integer;
  begin
    i:=fPlusNmodBB(ord(c1)-32+(ord(c2)-32)*B,n);
    //Funktion angewandt auf i von der Form i=a+b*B
    c1:=char(i mod B +32);  //mod wie Punkt- vor Strichrechnung
    c2:=char(i div B+32);   //div ist Punktrechnung: Keine Klammer ntig
  end;

begin
  key:=key mod BB;
  if length(s) mod 2<>0 then s:=s+' '; //Lnge gerade Zahl
  for k:=1 to length(s) div 2 do
    VerschlZweierBlock(s[2*k-1],s[2*k],key); //Fr k=1 s[1],s[2], fr k=2 s[3],s[4], ...
  result:=s;
end;

function dan_dekrypt(s:string;key:integer):string;
begin
  result:=dan_krypt(s,-key);
end;
//--------------------------------------------------------------------------
procedure dan_token(srch:string;var s,token:string;casesensitiv:bool);
var
  c:integer;
  ss,sss:string;
begin
  if casesensitiv then begin
    ss:=s;
    sss:=srch;
  end
  else begin
    ss:=ansiuppercase(s);
    sss:=ansiuppercase(srch);
  end;
  token:='';
  c:=pos(sss,ss);
  if c>0 then begin
    token:=copy(s,1,c-1);
    s:=copy(s,c+length(srch),length(s));
  end
  else begin
    token:=s;
    s:='';
  end;
end;

//--------------------------------------------------------------------------
function dan_prg(prg,param:string;var status:string):bool;
var
  rc:integer;
  s:string;
begin
  rc:=ShellExecute(application.handle,NIL,PChar(prg),pchar(param),pchar(extractfilepath(prg)),SW_SHOWNORMAL);
  if rc>32 then begin
    result:=true;
    status:='"'+prg+' '+param+'" aufgerufen';
  end
  else begin
    s:='ShellAPI-Fehler (#'+inttostr(rc)+') bei Aufruf von "'+prg+' '+param+'"';
    result:=false;
  end;
end;

//----------------------------------------------------------------------------
function dan_regGetExeForExt(Ext:string):string;
var
  reg:TRegistry;
  s:string;
begin
  s:='';
  reg:=TRegistry.Create;
  reg.RootKey:=HKEY_CLASSES_ROOT;
  if reg.OpenKey('.'+ext+'\shell\open\command',false) then begin
    {The open command has been found}
    s:=reg.ReadString('');
    reg.CloseKey;
  end
  else begin
    {perhaps there is a system file pointer}
    if reg.OpenKey('.'+ext, false) then begin
      s:=reg.ReadString('');
      reg.CloseKey;
      if s<>'' then begin
        {A system file pointer was found}
        if reg.OpenKey(s+'\shell\open\command', false) then
          {The open command has been found}
          s:=reg.ReadString('');
        reg.CloseKey;
      end;
    end;
  end;
  {Delete any command line, quotes and spaces}
  if Pos('%',s)>0 then Delete(s,Pos('%',s),length(s));
  if length(s)>0 then if s[1]='"' then Delete(s,1,1);
  if length(s)>0 then if s[length(s)]='"' then Delete(s,Length(s),1);
  while length(s)>0 do begin
    if not((s[length(s)]=#32) or (s[length(s)]='"')) then break;
    Delete(s,Length(s),1);
  end;
  Result:=s;
end;

function dan_regSetExeForExt(exename,extension:string):bool;
var
  key:HKey;
  s,typename:string;
begin
  s:=extractfilename(exename);
  s:=copy(s,1,length(s)-length(extractfileext(s)));

  typename:=s;
  Result:=false;

  if RegCreateKey(HKEY_CLASSES_ROOT,pchar(extension),key)<>ERROR_SUCCESS then
    exit;
  s:=typename;
  if RegSetValue(key,nil,REG_SZ,pchar(s),0)<>ERROR_SUCCESS then begin
    RegCloseKey(key);
    RegDeleteKey(HKEY_CLASSES_ROOT,pchar(extension));
    exit;
  end;
  RegCloseKey(key);

  s:=typename+'\DefaultIcon';
  if RegCreateKey(HKEY_CLASSES_ROOT,pchar(s),key)<>ERROR_SUCCESS then begin
    RegCloseKey(key);
    RegDeleteKey(HKEY_CLASSES_ROOT,pchar(extension));
    exit;
  end;
  s:=exename+',0';
  if RegSetValue(key,nil,REG_SZ,pchar(s),0)<>ERROR_SUCCESS then begin
    RegCloseKey(key);
    RegDeleteKey(HKEY_CLASSES_ROOT,pchar(extension));
    exit;
  end;
  RegCloseKey(key);

  s:=typename+'\shell\open\command';
  if RegCreateKey(HKEY_CLASSES_ROOT,pchar(s),key)<>ERROR_SUCCESS then begin
    RegCloseKey(key);
    RegDeleteKey(HKEY_CLASSES_ROOT,pchar(extension));
    exit;
  end;
  s:=exename+' "%1"';
  if RegSetValue(key,nil,REG_SZ,pchar(s),0)<>ERROR_SUCCESS then begin
    RegCloseKey(key);
    RegDeleteKey(HKEY_CLASSES_ROOT,pchar(extension));
    exit;
  end;
  RegCloseKey(key);

  Result:=true;
end;

function dan_regKillExtForExe(extension,exename:string):bool;
var
  s,typename:string;
begin
  Result:=true;
  s:=extractfilename(exename);
  s:=copy(s,1,length(s)-length(extractfileext(s)));
  typename:=s;
  if RegDeleteKey(HKEY_CLASSES_ROOT,pchar(extension))<>ERROR_SUCCESS then
    result:=false;
  {
  if RegDeleteKey(HKEY_CLASSES_ROOT,pchar(typename))<>ERROR_SUCCESS then
    result:=false;
  }
end;


end.

