unit hauptu;

// mplayer -vf framestep=i1 d:\tmp\b.mpg
// presentation time stamps (PTS)

{avi:

avi-splitter verwwendet wohl TDSFilterGraphp2.FilterGraph.AutoConnect
msvcrtd.dll

{
Wann ein Frame beim Decoder ankommt und wann er auf dem Bildschirm
ausgegeben werden soll, ist exakt fr jeden Frame innerhalb des
MPEG-Stroms durch Zeitstempel festgelegt. Der Presentation Time Stamp (PTS)
legt fest, wann der Frame beim Decoder ankommen soll und der
Display Time Stamp (DTS) bestimmt, wann der Frame angezeigt werden soll.
Der DTS muss immer grer als der PTS sein, weil der Decoder die Frames erst
verarbeiten muss, bevor er sie anzeigen kann. Andernfalls kann es zu
Bildstrungen kommen.
}

{
SCR: system clock reference
DTS: decoding time stamp
PTS: presentation time stamp

SCR 90 MHz


Synchronization
---------------
During encoding:
insert SCR values into system stream
stamp each frame with PTS and DTS
use encode time to approx. decode time


MPG2:
Zustzlich PCR: Program Clock Reference
SCR und PCR 27 MHz
}


{
procedure THiddenForm.GetProperties(FileName: string;
  var MediaFrames, MediaLength, MediaWidth, MediaHeight: Integer);
begin
  MediaPlayer.FileName := FileName;
  MediaPlayer.Wait     := False;
  MediaPlayer.Open;
  MediaPlayer.TimeFormat := tfFrames;
  MediaFrames := MediaPlayer.Length;
  MediaPlayer.TimeFormat := tfMilliseconds;
  MediaLength := MediaPlayer.Length;
  MediaPlayer.DisplayRect := Rect(1, 1, 0, 0); //"0, 0" forces resolution autodetect
  MediaWidth  := MediaPlayer.DisplayRect.Right;
  MediaHeight := MediaPlayer.DisplayRect.Bottom;
  if (MediaWidth <= 0) or (MediaHeight <= 0) then
  begin
    //invalid values mean not video
    MediaWidth  := 0;
    MediaHeight := 0;
  end;
  MediaPlayer.Close;
end;
}


{
anzahl frames
I look at the first GOP and read the time code, then I jump
towards the end of the file, & look at the last GOP and read
the time code.
}

{
numPictures = numIPictures + numBPictures + numPPictures;
printf("Length of stream %2.2f\n\n", timelength = numPictures*1.0/VidRateNum[frame_rate_code]);

}


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, MPlayer, StdCtrls, ComCtrls, Menus, FileCtrl,
  Spin,danu,XPMan,inifiles,shellapi;

const
  _caption='Daniel Schwamm''s VidSplitt V1.0';
  _inifn='vidsplitter.ini';

  _cr=#13#10;

  _hdbufsz=800960;
  _frmmax=2000000;

  //mpg-tags------------------------------------
  _FRAME_tag    =$00;
  _PADDING_tag  =$be;
  _VIDEO_tag    =$e0;
  _AUDIO_tag    =$c0;
  _AUDIO2_tag   =$d0;
  _SYSTEM_tag   =$bb;
  _PACK_tag     =$ba;
  _SEQU_tag     =$b3;
  _GOP_tag      =$b8;
  _USER_tag     =$b2;
  _SEQERR_tag   =$b4;
  _SEQEND_tag   =$b7;  //nur am ende der letzten sequenz!
  _EXT_tag      =$b5;
  _PRGEND_tag   =$b9;

  _VSTREAM1_tag =$E0;
  _VSTREAM2_tag =$EF;

  _ASTREAM1_tag =$C0;
  _ASTREAM2_tag =$CF;


  _SLICE1_tag   =$01;
  _SLICE2_tag   =$AF;


  _STD_SYSTEM_CLOCK_FREQ=90000;

  //design
  _pbdx=18;


type
  Thauptf = class(TForm)
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    ffnen1: TMenuItem;
    N1: TMenuItem;
    Beenden1: TMenuItem;
    opendlg: TOpenDialog;
    pctrl: TPageControl;
    mvts: TTabSheet;
    tagts: TTabSheet;
    vp: TPanel;
    Panel1: TPanel;
    tag1lb: TListBox;
    tag2lb: TListBox;
    Splitter3: TSplitter;
    pb: TProgressBar;
    Systemchb: TCheckBox;
    packchb: TCheckBox;
    GOPchb: TCheckBox;
    padchb: TCheckBox;
    slicechb: TCheckBox;
    iframechb: TCheckBox;
    audiochb: TCheckBox;
    pframechb: TCheckBox;
    videochb: TCheckBox;
    bframechb: TCheckBox;
    sequenzchb: TCheckBox;
    dframechb: TCheckBox;
    userchb: TCheckBox;
    seqendchb: TCheckBox;
    syncchb: TCheckBox;
    showtagsb: TButton;
    taglb1rb: TRadioButton;
    taglb2rb: TRadioButton;
    startt: TTimer;
    afne: TEdit;
    Schliessen1: TMenuItem;
    statb: TStatusBar;
    Ansicht1: TMenuItem;
    szmax1: TMenuItem;
    szorig1: TMenuItem;
    showframeinxb: TButton;
    selp: TPanel;
    tbtrenn1p: TPanel;
    selcutb: TButton;
    selresetb: TButton;
    selpb: TPaintBox;
    sc: TScrollBar;
    mp: TMediaPlayer;
    pntb: TPaintBox;
    goplb: TListBox;
    splitsetb: TButton;
    splitlstdelb: TButton;
    splitsortb: TButton;
    splitdelb: TButton;
    tbtrenn2p: TPanel;
    splittb: TButton;
    autob: TButton;
    autose: TSpinEdit;
    soundchb: TCheckBox;
    XPManifest1: TXPManifest;
    N2: TMenuItem;
    httpwwwdanielschwammde1: TMenuItem;
    procedure Beenden1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ffnen1Click(Sender: TObject);
    procedure showtagsbClick(Sender: TObject);
    procedure tag1lbClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure starttTimer(Sender: TObject);
    procedure Schliessen1Click(Sender: TObject);
    procedure szmax1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure splittbClick(Sender: TObject);
    procedure showframeinxbClick(Sender: TObject);
    procedure selendbClick(Sender: TObject);
    procedure pntbPaint(Sender: TObject);
    procedure splittsortbClick(Sender: TObject);
    procedure autobClick(Sender: TObject);
    procedure selcutbClick(Sender: TObject);
    procedure selpbPaint(Sender: TObject);
    procedure scChange(Sender: TObject);
    procedure selresetbClick(Sender: TObject);
    procedure splitsetbClick(Sender: TObject);
    procedure splitlstdelbClick(Sender: TObject);
    procedure splitdelbClick(Sender: TObject);
    procedure splitsortbClick(Sender: TObject);
    procedure goplbClick(Sender: TObject);
    procedure pntbDblClick(Sender: TObject);
    procedure pntbClick(Sender: TObject);
    procedure httpwwwdanielschwammde1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    //dstb:tdstrackbar;

    homedir:string;

    hdbuf:array[0.._hdbufsz] of byte;
    gopbufp:pchar;
    gopnsbufp:pchar;

    frmtyp:array[0.._frmmax]of char;
    frmpos:array[0.._frmmax]of int64;
    frmnr :array[0.._frmmax]of integer;

    hdlen,hdlenpos:integer;

    orgw,orgh:integer;
    gopmaxsz:integer;
    framec:integer;
    frmno:integer;
    mcifrmno:integer;

    selbmp,bmp:tbitmap;
    tbzoom:integer;

    selrow,selstart,selend:integer;

    mvok:bool;
    splitwrkok:bool;


    procedure wrstat(s1,s2:string);
    procedure vidopen(fn:string);
    procedure mkpntb;
    procedure put_ts(buffer:pchar;offset:integer;ts:double);
    procedure setbuttons;
    procedure setvidsz;
    procedure mktbsel;

    function bin2int(bin:string):integer;
    function get_ts(buffer:pchar;offset:integer):double;
    function get_FuellBytes(buffer:pchar;offset,max:integer):Byte;
    function ftoa(f:double):string;
    function frame2gop(fnr:integer;nextok:bool):integer;
    function fill(i:integer;len:integer):string;
    function scanframes(fn:string;var gopc:integer):integer;
    function filesz(fn:string):int64;
    function splittfile(
      fhin:thandle;
      frmvon:integer;
      frmbis:integer;
      fnnach:string
    ):bool;

    function mcifrm2frm(i:integer):integer;
    function getgopsz(frm:integer):int64;
    function sz2str(l:extended):string;
    function getsplittinfo(von,bis:integer):string;
    function selx2frm(x:integer):integer;
  end;

var
  hauptf: Thauptf;

implementation

{$R *.dfm}

//------------------------------------------------------------------------
procedure thauptf.wrstat(s1,s2:string);
begin
  if s1<>'-1' then statb.Panels[0].text:=s1;
  if s2<>'-1' then statb.Panels[1].text:=s2;
end;

function thauptf.fill(i:integer;len:integer):string;
begin
  result:=inttostr(i);
  while length(result)<len do result:='0'+result;
end;

{
procedure Thauptf.tbMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  try
    tb.Tag:=1;
    i:=x-10;if x<0 then i:=0;
    i:=round(
      (tb.max/(tb.width-20))
      *i
    );
    if ssshift in shift then begin
      if i<selstart then begin
        selend:=selstart;
        selstart:=i;
      end
      else begin
        selend:=i;
      end;
    end
    else begin
      selstart:=i;
      selend:=i;
    end;
    mktbsel;
    selpbPaint(self);

    tb.Position:=i;
    mp.position:=tb.position;
    wrstat('Frame: '+inttostr(mp.position),'-1');

  except
  end;
end;
}


procedure Thauptf.FormCreate(Sender: TObject);
begin
  selbmp:=tbitmap.Create;
  selbmp.PixelFormat:=pf24bit;
  bmp:=tbitmap.Create;
  bmp.PixelFormat:=pf24bit;
  tbzoom:=1;
  selrow:=-1;
  splitwrkok:=false;

  selp.ParentBackground:=false;selp.color:=clbtnface;
  tbtrenn1p.BevelOuter:=bvnone;
  tbtrenn2p.BevelOuter:=bvnone;
  selstart:=0;
  selend:=0;
  mkpntb;

  {
  tsc(sc).OnMouseDown:=scMouseDown;
  tsc(sc).OnMousemove:=scMousemove;
  tsc(sc).OnMouseup:=scMouseup;
  }

  homedir:=extractfilepath(application.exename);
  vp.align:=alclient;

  mp.Display:=vp;
  tag2lb.width:=220;
  tag1lb.align:=alclient;

  pctrl.align:=alclient;
  vp.Parentbackground:=false;vp.color:=clgray;
  //tbp.ParentBackground:=false;tbp.Color:=clbtnface;

  pctrl.ActivePageIndex:=0;


  {
  dstb:=tdstrackbar.Create(tbp);
  dstb.Align:=altop;
  dstb.ThumbLength:=20;
  dstb.Height:=40;
  dstb.TickMarks:=dstmTopLeft;
  dstb.Parent:=tbp;
  }

  wrstat('','Kein Movie geffnet');
end;

procedure Thauptf.Beenden1Click(Sender: TObject);
begin
  mp.close;
  close;
end;

procedure Thauptf.ffnen1Click(Sender: TObject);
begin
  if not opendlg.execute then exit;
  vidopen(opendlg.filename);
end;

procedure Thauptf.tag1lbClick(Sender: TObject);
begin
  if syncchb.checked then tag2lb.ItemIndex:=tag1lb.ItemIndex;
end;

function Thauptf.bin2int(bin : string) : integer;
  var a,z : integer;
begin
  result := 0;
  a := 1;
  for z := length(bin) downto 1 do  begin
    if bin[z]='1' then inc(result,a);
    a := a * 2;
  end;
end;

function thauptf.get_FuellBytes(buffer:pchar;offset,max:integer):Byte;
begin
  Result:=0;
  while(offset<max)and(byte(buffer[offset])=$ff) do begin
    inc(offset);
    inc(result);
  end;
end;

function thauptf.ftoa(f:double):string;
begin
  result:=format('%.3f',[f]);
end;

procedure Thauptf.showtagsbClick(Sender: TObject);
const
  _bufmax=20;
var
  tbuf:array[0.._bufmax]of byte;

  function b2hex(b:byte):string;
  begin
    if b<10 then result:=inttostr(b)
    else result:=chr(ord('A')+(b-10));
  end;

  function hex(b:byte):string;
  begin
    //result:=inttostr(b); exit;
    result:=
      b2hex(b div 16)+
      b2hex(b mod 16);
  end;

  function itoa(i,len:integer):string;
  begin
    result:=inttostr(i);
    while length(result)<len do result:='0'+result;
  end;


  function getsz(offset:integer):integer;
  begin
    result:=byte(tbuf[offset])*256+byte(tbuf[offset+1]);
  end;


var
  fn:string;
  b,bb,bbb:byte;
  rd:integer;
  fh:thandle;
  lb:tlistbox;
  fc,i:integer;
  s,hs:string;
  hr,min,sec:integer;
  f:double;
  pts,dts:double;
  printok:bool;
  frmc:integer;
begin
  //fn:='d:\tmp\p.m1v';
  fn:=afne.Text;//.Directory+'\'+flb.Items[flb.itemindex];

  screen.cursor:=crhourglass;

  if taglb1rb.checked then lb:=tag1lb else lb:=tag2lb;

  lb.Hint:=afne.text;//flb.Items[flb.itemindex];
  lb.showhint:=true;
  lb.enabled:=false;
  lb.clear;
  lb.Items.add(afne.text);
  lb.Items.add('==========');

  mp.Close;

  fh:=FileOpen(fn,fmOpenRead);
  rd:=1;
  fc:=0;
  frmc:=0;
  while rd>0 do begin
    rd:=FileRead(fh,tbuf,_bufmax+1);

    if (rd>=4)then begin
      printok:=true;

      if(tbuf[0]=0)and(tbuf[1]=0)and(tbuf[2]=1)then begin

        s:='';
        b:=tbuf[3];
        if b=_SEQU_tag then begin
          //sequenz
          printok:=sequenzchb.checked;

          if printok then begin
            s:='SEQUENZ: ';

            b:=tbuf[4];
            bb:=tbuf[5];bb:=byte(bb shr 4);
            i:=b*16+bb;
            s:=s+inttostr(i)+'x';

            b:=tbuf[5];b:=byte(b shl 4);b:=byte(b shr 4);
            bb:=tbuf[6];
            i:=b*256+bb;
            s:=s+inttostr(i)+' ';

            b:=tbuf[7];b:=byte(b shr 4);

            //nur mpg-1?
            if      b= 1 then s:=s+'1/1(VGA) '
            else if b= 2 then s:=s+'4/3(TV) '
            else if b= 3 then s:=s+'16/9(Large TV PAL) '
            else if b= 4 then s:=s+'2.21/1(Cinema) '
            else if b= 5 then s:=s+'Asp:0.8055 '
            else if b= 6 then s:=s+'16/9(Large TV NTSC) '
            else if b= 7 then s:=s+'Asp:0.8935 '
            else if b= 8 then s:=s+'4/3(CCIR601 PAL) '
            else if b= 9 then s:=s+'Asp:0.9815 '
            else if b=10 then s:=s+'Asp:1.0255 '
            else if b=11 then s:=s+'Asp:1.0695 '
            else if b=12 then s:=s+'4/3(CCIR601 NTSC) '
            else if b=13 then s:=s+'Asp:1.1575 '
            else if b=14 then s:=s+'Asp:1.2015 '
            else             s:=s+'?-Aspect('+inttostr(b)+') ';


            b:=tbuf[7];b:=byte(b shl 4);b:=byte(b shr 4);
            if      b=1 then s:=s+'23.976fps(EncapsNTSC) '
            else if b=2 then s:=s+'24fps(Cinema) '
            else if b=3 then s:=s+'25fps(PAL) '
            else if b=4 then s:=s+'29.97fps(NTSC) '
            else if b=5 then s:=s+'30fps(DropNTSC) '
            else if b=6 then s:=s+'50fps(DoublePAL) '
            else if b=7 then s:=s+'59.94fps(DoubleNTSC) '
            else if b=8 then s:=s+'60fps(DoubleDropNTSC) '
            else             s:=s+itoa(b,1)+'=Err-Framerate ';

            b:=tbuf[8];
            bb:=tbuf[9];
            bbb:=tbuf[10];bbb:=byte(bbb shr 6);
            i:=b*1024+bb*4+bbb;
            i:=(i*400)div 1000;
            s:=s+'BR:'+inttostr(i)+'kbps ';

            // $3FFFF bedeutet variable bitrate

            //maerkbit muss immer eins sein

            //vbv: DekodierbufferGrsse in 16kB Blcken
          end;

        end
        else if b=_GOP_tag then begin
          //gop
          printok:=gopchb.checked;

          if printok then begin
            lb.items.add('-----');
            s:='GOP: ';

            b:=tbuf[4];
            if (b and bin2int('10000000')=128) then s:=s+'DRP ' else s:=s+'!DRP ';

            b:=tbuf[4];b:=byte(b shl 1);b:=byte(b shr 3);hr:=b;
            s:=s+'H:'+itoa(b,1)+' ';

            b:=tbuf[4];b:=byte(b shl 5);b:=byte(b shr 5);
            bb:=tbuf[5];bb:=byte(bb shr 4);
            i:=b*16+bb;min:=i;
            s:=s+'M:'+itoa(i,2)+' ';

            b:=tbuf[5];b:=byte(b shl 5);b:=byte(b shr 5);
            bb:=tbuf[6];bb:=byte(bb shr 5);
            i:=b*8+bb;sec:=i;
            s:=s+'S:'+itoa(i,2)+' ';

            {
            //geht aus so
            i:=((tbuf[6] and $1F) shl 1)+(tbuf[7] shr 7);
            }
            b:=tbuf[6];b:=byte(b shl 3);b:=byte(b shr 3);
            bb:=tbuf[7];bb:=byte(bb shr 7);
            i:=b*2+bb;
            s:=s+'F:'+itoa(i,2)+' ';

            hr:=(hr*60+min)*60+sec;
            s:=s+'P:'+inttostr(hr)+'s ';

            b:=tbuf[7];
            if (b and bin2int('1000000')=64) then s:=s+'CLS ' else s:=s+'!CLS ';
            if (b and bin2int('100000')=32) then s:=s+'BRK ' else s:=s+'!BRK ';
          end;

        end
        else if b=_FRAME_tag then begin

          //frame
          s:='FRAME: ';

          b:=tbuf[4];b:=byte(b shl 5);b:=byte(b shr 5);
          bb:=tbuf[5];bb:=byte(bb shr 6);
          i:=b*4+bb;
          s:=s+'SEQ:'+itoa(i,3)+' ';

          b:=tbuf[5];b:=byte(b shl 2);b:=byte(b shr 5);
          if      b=0 then begin s:=s+'L-FRAME ';printok:=true;end
          else if b=1 then begin s:=s+'I-FRAME ';printok:=iframechb.checked;end
          else if b=2 then begin s:=s+'P-Frame ';printok:=pframechb.checked;end
          else if b=3 then begin s:=s+'B-Frame ';printok:=bframechb.checked;end
          else if b=4 then begin s:=s+'D-Frame ';printok:=dframechb.checked;end
          else             begin s:=s+hex(b)+'-Frame? ';printok:=false;end;

          if printok then begin
            b:=tbuf[5];b:=byte(b shl 5);b:=byte(b shr 5);
            bb:=tbuf[6];
            bbb:=tbuf[7];bbb:=byte(bbb shr 3);
            i:=b*(32*256)+bb*32+bbb;

            //variable: ffff

            s:=s+'VBVDelay:'+format('%.4fs ',[i/_STD_SYSTEM_CLOCK_FREQ]);

            s:=s+'Frmc:'+inttostr(frmc);
            inc(frmc);
          end;


        end
        else if b=_PADDING_tag then begin
          printok:=padchb.checked;
          if printok then s:='PADDING '+inttostr(Getsz(4));
        end

        else if b=_SYSTEM_tag then begin
          printok:=systemchb.checked;
          if printok then s:='SYSTEM '+inttostr(Getsz(4));
        end
        else if b=_PACK_tag then begin
          printok:=packchb.checked;
          if printok then begin
            s:='PACK ';

            b:=tbuf[4];b:=byte(b shl 1);b:=byte(b shr 3);
            s:=s+'H:'+itoa(b,1)+' ';

            b:=tbuf[4];b:=byte(b shl 5);b:=byte(b shr 5);
            bb:=tbuf[5];bb:=byte(bb shr 4);
            i:=b*16+bb;
            s:=s+'M:'+itoa(i,2)+' ';

            b:=tbuf[5];b:=byte(b shl 5);b:=byte(b shr 5);
            bb:=tbuf[6];bb:=byte(bb shr 5);
            i:=b*8+bb;
            s:=s+'S:'+itoa(i,2)+' ';

            f:=get_ts(@tbuf,4);

            s:=s+'SCR:'+ftoa(f);
          end;
        end
        else if b=_USER_tag then begin
          printok:=userchb.checked;
          if printok then s:='USER DATA';
        end
        else if b=_SEQERR_tag then begin
          s:='SEQUENZ FEHLER';
        end
        else if b=_SEQEND_tag then begin
          printok:=seqendchb.checked;
          if printok then s:='SEQUENZ ENDE';
        end
        else if b=_EXT_tag then begin
          s:='EXTENSION';
        end
        else if b=_PRGEND_tag then begin
          s:='PROG ENDE';
        end
        else if (b>=_SLICE1_tag)and(b<=_SLICE2_tag) then begin
          printok:=slicechb.checked;
          if printok then s:='SLICE';
        end
        else if
          (b>=_ASTREAM1_tag)and(b<=_ASTREAM2_tag)or
          (b>=_VSTREAM1_tag)and(b<=_VSTREAM2_tag)
        then begin
          if(b>=_ASTREAM1_tag)and(b<=_ASTREAM2_tag)then begin
            s:='ASTREAM ';
            printok:=audiochb.checked;
          end
          else begin
            s:='VSTREAM ';
            printok:=videochb.checked;
          end;

          if printok then begin
            s:=s+'HL:'+inttostr(Getsz(4))+' ';

            i:=Get_fuellbytes(@tbuf,6,_bufmax);
            s:=s+'FB:'+inttostr(i)+' ';

            i:=i+6;
            b:=byte(tbuf[i]);b:=byte(b shr 7);
            bb:=byte(tbuf[i]);bb:=byte(bb shl 1);bb:=byte(bb shr 7);
            if(b=0)and(bb=1)then begin
              s:=s+'STD ';
              i:=i+2;
            end
            else begin
              s:=s+'!STD ';
            end;

            //if fc=2091 then beep;

            //presentation / decode time stamp
            b:=byte(tbuf[i]);b:=byte(b shl 2);b:=byte(b shr 7);
            bb:=byte(tbuf[i]);bb:=byte(bb shl 3);bb:=byte(bb shr 7);
            b:=byte(b*2+bb);

            if b=0 then begin
              s:=s+'!PTS !DTS ';
            end
            else if b=1 then begin
              s:=s+'PTS/DTS-Error ';
            end
            else if b=2 then begin
              pts:=get_ts(@tbuf,i);
              s:=s+'PTS:'+ftoa(pts)+'s !DTS ';
            end
            else if b=3 then begin
              pts:=get_ts(@tbuf,i);
              i:=i+5;
              dts:=get_ts(@tbuf,i);
              s:=s+'PTS:'+ftoa(pts)+'s DTS:'+ftoa(dts)+'s ';
            end;
          end;
        end

        else begin
          s:='?';
        end;

        if printok then begin
          hs:=inttohex(fc,7);
          lb.items.add(hs+':'+hex(tbuf[3])+' -> '+s);
        end;

      end;
      fileseek(fh,-(rd-1),1);
      inc(fc);
    end
    else begin
      break;
    end;

    //if lb.count>2500 then break;
  end;
  fileclose(fh);

  lb.enabled:=true;

  //vidopen(afne.text);
  mp.open;

  screen.cursor:=crdefault;
end;

procedure Thauptf.FormDestroy(Sender: TObject);
var
  s:string;
begin
  danu.dan_wrfrmini(tform(self),homedir+_inifn,s);
  with tinifile.Create(homedir+_inifn)do begin
    writebool('mvsz','szorig1',szorig1.Checked);
    writebool('mvsz','szmax1',szmax1.Checked);
    free;
  end;
end;

function thauptf.filesz(fn:string):int64;
var
  sr:_WIN32_FIND_DATA;
  h:thandle;
begin
  result:=-1;
  h:=findfirstfile(pchar(fn),sr);
  try
    if h<>INVALID_HANDLE_VALUE then begin
      result:=(sr.nFileSizeHigh*MAXDWORD)+sr.nFileSizeLow;
    end;
  finally
    windows.FindClose(h);
  end;
end;

function thauptf.frame2gop(fnr:integer;nextok:bool):integer;
var
  r:integer;
  foundok:bool;
begin

  //framenr im tag-array finden
  foundok:=false;
  for r:=0 to framec-2 do begin
    if frmnr[r]<>fnr then continue;
    foundok:=true;
    fnr:=r;
    break;
  end;

  if not foundok then begin
    //frame nicht gefunden
    if not nextok then begin
      //nimm ersten gop
      for r:=0 to framec-2 do begin
        if frmtyp[r]<>'G' then continue;
        result:=r;
        exit;
      end;
    end
    else begin
      //nimm letzen gop
      for r:=framec-2 downto 0 do begin
        if frmtyp[r]='G' then begin
          result:=r;
          exit;
        end;
      end;
    end;

    //fehler
    result:=-1;
    exit;
  end;

  if fnr<0 then fnr:=0;
  if(fnr>framec-2)or(fnr>_frmmax-2) then fnr:=framec-2;


  if not nextok then begin
    for r:=fnr downto 0 do begin
      if frmtyp[r]='G' then begin
        result:=r;
        exit;
      end;
    end;
    result:=0;
  end
  else begin
    for r:=fnr to framec-2 do begin
      if frmtyp[r]='G' then begin
        result:=r;
        exit;
      end;
    end;
    result:=framec-2;
  end;
end;

//-------------------------------------------------------------------------
procedure Thauptf.starttTimer(Sender: TObject);
var
  s:string;
begin
  startt.enabled:=false;
  danu.dan_rdfrmini(tform(self),homedir+_inifn,s);
  with tinifile.Create(homedir+_inifn)do begin
    szorig1.Checked:=readbool('mvsz','szorig1',true);
    szmax1.Checked:=readbool('mvsz','szmax1',false);
    free;
  end;

  setbuttons;
  FormResize(sender);

  //afne.Text:='d:\tmp\shb.mpg';
  if afne.text<>'' then vidopen(afne.text);

end;

//-------------------------------------------------------------------------
procedure Thauptf.Schliessen1Click(Sender: TObject);
begin
  mp.close;
  afne.text:='';
  mp.FileName:='';
  setbuttons;
end;

//-------------------------------------------------------------------------
procedure Thauptf.szmax1Click(Sender: TObject);
begin
  setvidsz;
end;


//----------------------------------------------------------------------------
procedure Thauptf.FormResize(Sender: TObject);
begin
  setvidsz;
  mkpntb;
  selpbPaint(Sender);
  pntbPaint(Sender);
  setbuttons;
end;

//--------------------------------------------------------------------------
procedure Thauptf.showframeinxbClick(Sender: TObject);
var
  r:integer;
  lb:tlistbox;
  s,typ:string;
begin
  screen.Cursor:=crhourglass;
  if taglb1rb.checked then lb:=tag1lb else lb:=tag2lb;

  lb.Hint:=afne.text;//flb.Items[flb.itemindex];
  lb.showhint:=true;
  lb.enabled:=false;
  lb.clear;
  lb.Items.add(afne.text);
  lb.Items.add('==========');

  for r:=0 to framec-1 do begin
    typ:=frmtyp[r];

    if(typ='G')and not gopchb.Checked    then continue;
    if(typ='C')and not packchb.Checked   then continue;
    if(typ='A')and not audiochb.Checked  then continue;
    if(typ='V')and not videochb.Checked  then continue;
    if(typ='I')and not iframechb.Checked then continue;
    if(typ='P')and not pframechb.Checked then continue;
    if(typ='B')and not bframechb.Checked then continue;
    if(typ='D')and not dframechb.Checked then continue;

    if typ='G' then lb.items.add('-------');

    s:=typ;
    if typ='G' then s:='GOP';
    if typ='C' then s:='PACK';
    if typ='A' then s:='ASTREAM';
    if typ='V' then s:='VSTREAM';
    if typ='I' then s:='IFrame    '+inttostr(frmnr[r]);
    if typ='P' then s:='PFrame    '+inttostr(frmnr[r]);
    if typ='B' then s:='BFrame    '+inttostr(frmnr[r]);
    if typ='D' then s:='DFrame    '+inttostr(frmnr[r]);
    if typ='L' then s:='LeerFrame '+inttostr(frmnr[r]);

    s:=fill(r,5)+' - '+inttohex(frmpos[r],7)+': '+s;
    lb.items.add(s);
  end;
  lb.enabled:=true;
  screen.Cursor:=crdefault;
end;

//------------------------------------------------------------------------
function thauptf.get_ts(buffer:pchar;offset:integer):double;
var
  //highbit:byte;
  low4Bytes:integer;
  TS:double;
begin
   //highbit:=(byte(buffer[offset])shr 3)and $01;
   //muss auf null, sonst knallts

   low4Bytes :=((byte(buffer[offset]) shr 1) and $03) shl 30;
   low4Bytes :=low4Bytes or byte(buffer[offset+1]) shl 22; // hours
   low4Bytes :=low4Bytes or (byte(buffer[offset+2]) shr 1) shl 15; // minutes
   low4Bytes :=low4Bytes or byte(buffer[offset+3]) shl 7;
   low4Bytes :=low4Bytes or byte(buffer[offset+4]) shr 1;

   TS:=low4Bytes;
   TS:=TS/_STD_SYSTEM_CLOCK_FREQ;

   result:=TS;
   exit;

   {
   highbit:=(byte(buffer[offset])shr 3)and $01;
   //muss auf null, sonst knallts

   low4Bytes :=((byte(buffer[offset]) shr 1) and $03) shl 30;
   low4Bytes :=low4Bytes or byte(buffer[offset+1]) shl 22; // hours
   low4Bytes :=low4Bytes or (byte(buffer[offset+2]) shr 1) shl 15; // minutes
   low4Bytes :=low4Bytes or byte(buffer[offset+3]) shl 7;
   low4Bytes :=low4Bytes or byte(buffer[offset+4]) shr 1;

   TS:=highbit*$10000*$10000+low4Bytes;
   TS:=TS/_STD_SYSTEM_CLOCK_FREQ;

   result:=TS;
   }

   {
   highbit= (buffer[offset]>>3)&0x01;

   low4Bytes = ((buffer[offset] >> 1) & 0x03) << 30;
   low4Bytes |= buffer[offset + 1] << 22; // hours
   low4Bytes |= (buffer[offset + 2] >> 1) <<15; // minutes
   low4Bytes |= buffer[offset + 3] << 7;
   low4Bytes |= buffer[offset + 4] >> 1;
   }

end;


//------------------------------------------------------------------------
procedure thauptf.put_ts(buffer:pchar;offset:integer;ts:double);
var
  uppercode:byte;
  hibit:byte;
  ats,d:double;
  lowint:integer;
  //hour,min,sec,pics:integer;
begin
  ats:=ts;
  uppercode:=byte(buffer[offset]) and $F0;

  ats:=ats*_STD_SYSTEM_CLOCK_FREQ;
  d:=$10000;
  d:=d*$10000;
  if ats>d then begin
    hiBit:=1;
    ats:=ats-d;
    lowInt:=trunc(aTS);
  end
  else begin
    hiBit:=0;
    lowInt:=trunc(aTS);
  end;

  uppercode:=uppercode or (hiBit shl 3) or ((lowInt and $C0000000) shr 29) or $01;
  lowInt:=$00010001 or ((lowInt and $3FFF8000) shl 2) or ((lowInt and $00007FFF) shl 1);

  buffer[offset]   := char(uppercode);
  buffer[offset+1] := char(lowInt shr 24);
  buffer[offset+2] := char((lowInt shr 16)and $FF);
  buffer[offset+3] := char((lowInt shr 8)and $FF);
  buffer[offset+4] := char(lowInt and $FF);

{

  byte uppercode = buffer[offset] & 0xF0;
  byte hiBit;
  long lowInt=0;
  double TS=ts;
  int hour;
  int minute;
  int sec;
  int pics;


  TS *= STD_SYSTEM_CLOCK_FREQ;
  if (TS > FLOAT_0x10000 * FLOAT_0x10000) *
    hiBit = 1;
    TS -= FLOAT_0x10000 * FLOAT_0x10000;
  *
  else *
    hiBit = 0;
    lowInt = (long) TS;
  *


    uppercode = uppercode |
      (hiBit << 3) |
      ((lowInt & 0xC0000000) >> 29) |
      0x01;

    lowInt = 0x00010001 |
      ((lowInt & 0x3FFF8000) << 2) |
      ((lowInt & 0x00007FFF) << 1);

    buffer[offset] = uppercode;
    buffer[offset+1] = (byte)(lowInt>>24);
    buffer[offset+2] = (byte)((lowInt>>16)&0xFF);
    buffer[offset+3] = (byte)((lowInt>>8)&0xFF);
    buffer[offset+4] = (byte)(lowInt&0xFF);
}
end;

procedure Thauptf.selendbClick(Sender: TObject);
begin
end;

//----------------------------------------------------------------------------
procedure Thauptf.vidopen(fn:string);
var
  gopc,frmc:integer;
begin
  try
    mp.close;
  except
  end;

  try
    wrstat('','Scanne Tags von "'+fn+'" ...');
    frmc:=scanframes(fn,gopc);
    afne.text:=fn;

    mp.FileName:=fn;
    mp.open;

    mp.TimeFormat:=tfFrames;
    orgw:=mp.DisplayRect.Right;
    orgh:=mp.DisplayRect.Bottom;

    mcifrmno:=mp.length;
    sc.min:=0;
    sc.Max:=mp.Length;
    sc.Position:=1;

    afne.text:=fn;
    setvidsz;
    FormResize(self);

    //caption:=inttostr(frmc)+' | GOPs:'+inttostr(gopc);
    wrstat('-1','Movie "'+fn+'" geffnet ==> '+inttostr(frmc)+' Tag-Infos Frames: '+inttostr(frmno));

  except
    wrstat('-1','FEHLER! Konnte Movie "'+fn+'" nicht ffnen.');
    //afne.text:='';
  end;
  setbuttons;
  screen.Cursor:=crdefault;
end;

procedure Thauptf.pntbPaint(Sender: TObject);
begin
  if bmp=nil then exit;
  try
  bitblt(
    pntb.Canvas.Handle,0,0,pntb.width,pntb.Height,
    bmp.canvas.handle,0,0,
    srccopy
  );
  except
  end;
end;

procedure Thauptf.splittsortbClick(Sender: TObject);
begin
end;

//-----------------------------------------------------------------------
function thauptf.mcifrm2frm(i:integer):integer;
var
  d:double;
begin
  result:=0;if mcifrmno=0 then exit;
  d:=frmno/mcifrmno;
  i:=trunc(i*d);
  result:=i;
end;

procedure Thauptf.autobClick(Sender: TObject);
var
  r,von,bis:integer;
  dx,d:double;
begin
  if autose.value=0 then exit;
  goplb.Clear;
  d:=mcifrmno/autose.value;
  dx:=0;
  bis:=0;
  for r:=0 to autose.value-1 do begin
    von:=bis;
    bis:=trunc(von+d);
    goplb.Items.add(fill(von,7)+':'+fill(bis,7));
    dx:=dx+d;
  end;
  formresize(self);
end;

//---------------------------------------------------------------------
procedure Thauptf.splittbClick(Sender: TObject);
var
  fhin:thandle;
  pi,c,nr,frmv,frmb:integer;
  s,fno,fn,ext:string;
begin
  if goplb.items.count=0 then exit;


  screen.Cursor:=crhourglass;
  pi:=mp.Position;
  mp.Close;

  //gop-speicher allokieren
  gopbufp:=Pchar(AllocMem(gopmaxsz+1));

  //ohne sound variante
  gopnsbufp:=Pchar(AllocMem(gopmaxsz+1));


  fhin:=FileOpen(afne.text,fmOpenRead);
  try
    fno:=afne.Text;
    ext:=extractfileext(fno);
    fno:=copy(fno,1,length(fno)-length(ext));

    pb.Max:=goplb.Items.count;
    for nr:=0 to goplb.Items.count-1 do begin
      pb.Position:=nr+1;
      application.processmessages;

      s:=goplb.Items[nr];
      c:=pos(':',s);if c=0 then continue;
      frmv:=strtoint(copy(s,1,c-1));
      frmv:=mcifrm2frm(frmv);

      frmb:=strtoint(copy(s,c+1,length(s)));
      frmb:=mcifrm2frm(frmb);

      fn:=fno+'_'+fill(nr,3)+ext;
      splittfile(fhin,frmv,frmb,fn);
    end;

  finally
    fileclose(fhin);
    freemem(gopnsbufp);
    freemem(gopbufp);

    //vidopen(afne.text);
    mp.Open;
    mp.Position:=pi;
    formresize(nil);
    pb.Position:=0;
    screen.cursor:=crdefault;
  end;
end;


//------------------------------------------------------------------------
function thauptf.getgopsz(frm:integer):int64;
var
  r:integer;
begin
  result:=frmpos[frm];
  for r:=frm+1 to framec-1 do begin
    if frmtyp[r]<>'G' then continue;
    result:=frmpos[r]-result;
    exit;
  end;
  result:=frmpos[framec-1]-result;
end;


procedure Thauptf.selcutbClick(Sender: TObject);
begin
  sc.Min:=selstart;
  sc.max:=selend;
  formresize(self);
end;

procedure Thauptf.selresetbClick(Sender: TObject);
begin
  sc.Min:=0;
  sc.max:=mp.length;
  formresize(self);
end;

procedure Thauptf.selpbPaint(Sender: TObject);
begin
  if selbmp=nil then exit;
  try
  bitblt(
    selpb.Canvas.Handle,0,0,selpb.width,selpb.Height,
    selbmp.canvas.handle,0,0,
    srccopy
  );
  except
  end;
end;

procedure Thauptf.splitsetbClick(Sender: TObject);
var
  s:string;
begin
  if(selrow<>-1)and splitwrkok then begin
    //gewhlten splitt adaptieren
    s:=fill(selstart,7)+':'+fill(selend,7);
    goplb.Items[selrow]:=s;
    FormResize(sender);
    exit;
  end;


  //neuen splitt setzen
  s:=fill(selstart,7)+':'+fill(selend,7);
  goplb.Items.add(s);
  FormResize(sender);
end;

procedure Thauptf.scChange(Sender: TObject);
var
  i,rc:integer;
begin
  i:=sc.position;
  rc:=getkeystate(VK_control);
  if rc<0 then begin
    if i<selstart then begin
      selend:=selstart;
      selstart:=i;
    end
    else begin
      selend:=i;
    end;
  end
  else begin
    selstart:=i;
    selend:=i;
  end;
  mktbsel;
  selpbPaint(self);

  sc.Position:=i;
  mp.position:=sc.position;
  wrstat('Frame: '+inttostr(mp.position),'-1');
  setbuttons;
end;

//------------------------------------------------------------------------
procedure thauptf.mktbsel;
var
  i,c,dx,von,bis,w:integer;
  d,dz:double;
  clr,cl:tcolor;
  s:string;
begin
  dx:=_pbdx;
  w:=(sc.Width-(2*dx)-14);
  d:=w/(sc.Max-sc.Min);

  //selection leeren
  clr:=clbtnface;cl:=clbtnface;
  selbmp.Canvas.pen.color:=clr;
  selbmp.Canvas.Brush.color:=cl; //clbtnface;
  selbmp.Canvas.Brush.style:=bssolid;
  selbmp.Width:=selpb.Width;
  selbmp.Height:=selpb.Height;
  selbmp.Canvas.Rectangle(0,0,selbmp.Width,selbmp.height);

  clr:=clgray;cl:=clsilver;
  selbmp.Canvas.pen.color:=clr;
  selbmp.Canvas.Brush.color:=cl;
  selbmp.Canvas.Rectangle(dx+sc.left,0,dx+w+sc.left,selbmp.height);

  //selektion einzeichnen
  clr:=clblack;cl:=clblue;
  selbmp.Canvas.pen.color:=clr;
  selbmp.Canvas.Brush.color:=cl;
  von:=trunc(dx+(selstart-sc.Min)*d)+sc.left;
  bis:=trunc(dx+(selend  -sc.Min)*d)+sc.left;

  if von=bis then bis:=von+1;
  selbmp.Canvas.Rectangle(von,0,bis,selbmp.height);

  //selektionsbereich?
  if bis-von>1 then begin
    s:='SELEKTION: '+getsplittinfo(selx2frm(von),selx2frm(bis));
    wrstat('-1',s);
  end;

  //zhler-striche
  selbmp.Canvas.Brush.style:=bsclear;
  clr:=clgray;
  selbmp.Canvas.pen.color:=clr;

  i:=(sc.Max-sc.min) div sc.largechange;
  if i>500 then i:=500;

  dz:=w/i;
  bis:=selbmp.Height;
  for c:=1 to i-1 do begin
    von:=dx+sc.left+trunc(c*dz);
    selbmp.canvas.MoveTo(von,bis-5);
    selbmp.canvas.lineTo(von,bis);
  end;

  //zhlerwerte
  selbmp.Canvas.Font.Name:='MS Sans Serif';
  selbmp.Canvas.Font.size:=6;
  selbmp.Canvas.Font.color:=clgray;

  i:=18;
  von:=dx+sc.left+2;
  s:=inttostr(sc.min);
  selbmp.Canvas.TextOut(von,bis-i,s);

  von:=dx+sc.left+(w div 2);
  s:=inttostr(sc.min+(sc.max-sc.min)div 2);
  von:=von-selbmp.Canvas.TextWidth(s) div 2;
  selbmp.Canvas.TextOut(von,bis-i,s);

  von:=dx+sc.left+w;
  s:=inttostr(sc.max);
  von:=von-selbmp.Canvas.TextWidth(s)-2;
  selbmp.Canvas.TextOut(von,bis-i,s);
end;

//------------------------------------------------------------------------
procedure thauptf.mkpntb;
var
  w,dx,c,r,von,bis:integer;
  s:string;
  d:double;
  clr,cl:tcolor;
begin
  //sc positionieren
  sc.Left:=8;
  sc.Height:=13;
  sc.width:=selpb.width-16;
  sc.Top:=selpb.Top+((selpb.Height-sc.height) div 3);

  mktbsel;

  dx:=_pbdx;
  w:=(sc.Width-(2*dx)-14);
  d:=w/(sc.Max-sc.Min);

  //bmp leeren
  clr:=clbtnface;cl:=clbtnface;
  bmp.Canvas.pen.color:=clr;
  bmp.Canvas.Brush.color:=cl;
  bmp.Canvas.Brush.style:=bssolid;
  bmp.Width:=pntb.Width;
  bmp.Height:=pntb.Height;
  bmp.Canvas.Rectangle(0,0,bmp.Width,bmp.height);

  clr:=clgray;cl:=clsilver;
  bmp.Canvas.pen.color:=clr;
  bmp.Canvas.Brush.color:=cl;
  bmp.Canvas.Rectangle(dx+sc.left,0,dx+w+sc.left,bmp.height);


  //bmp mit splitts fllen


  //d:=(sc.Width-_pbdx)/sc.Max;
  //dx:=_pbdx;

  for r:=0 to goplb.items.count-1 do begin
    s:=goplb.Items[r];
    c:=pos(':',s);if c=0 then c:=length(s)+1;
    von:=strtoint(trim(copy(s,  1,c-1      )));
    bis:=strtoint(trim(copy(s,c+1,length(s))));
    von:=trunc(dx+(von-sc.Min)*d)+sc.left;
    bis:=trunc(dx+(bis-sc.Min)*d)+sc.left;

    if r=selrow then begin
      if splitwrkok then bmp.Canvas.Brush.color:=cllime
                    else bmp.Canvas.Brush.color:=clgreen;
    end
    else begin
      bmp.Canvas.Brush.color:=clblue;
    end;

    bmp.Canvas.Rectangle(von,0,bis,bmp.height);
  end;
end;

procedure Thauptf.splitlstdelbClick(Sender: TObject);
begin
  goplb.Clear;
  FormResize(sender);
end;

procedure Thauptf.splitdelbClick(Sender: TObject);
begin
  goplb.DeleteSelected;
  FormResize(sender);
end;

procedure Thauptf.splitsortbClick(Sender: TObject);
begin
  goplb.Sorted:=true;
  goplb.Sorted:=false;
end;

//----------------------------------------------------------------------------
procedure thauptf.setvidsz;
var
  ow,oh,t,l,w,h:integer;
begin
  if not mp.CanFocus then exit;
  LockWindowUpdate(Handle);

  ow:=orgw;if ow=0 then ow:=vp.Clientwidth;
  oh:=orgh;if oh=0 then oh:=vp.ClientHeight;
  w:=ow;h:=oh;
  if szmax1.Checked then begin
    if(w/h)>(vp.ClientWidth/vp.clientheight)then begin
      //querformat
      w:=vp.ClientWidth-5;
      h:=trunc((w*oh)/ow);
    end
    else begin
      //hochformat
      h:=vp.Clientheight-5;
      w:=trunc((h*ow)/oh);
    end;
  end;

  l:=trunc((vp.ClientWidth-w)/2)+1;
  t:=trunc((vp.Clientheight-h)/2)+1;
  mp.DisplayRect:=rect(l,t,w,h);
  LockWindowUpdate(0);
end;

//-------------------------------------------------------------------------
procedure thauptf.setbuttons;
begin
  splitlstdelb.Enabled:=(goplb.Items.count>0);
  splitsortb.Enabled:=(goplb.Items.count>0);
  splitdelb.enabled:=(goplb.Itemindex<>-1);

  //video geladen?
  if mp.DeviceID=0 then begin
    //nein
    Schliessen1.enabled:=false;
    sc.enabled:=false;

    selcutb.Enabled:=false;
    selresetb.Enabled:=false;

    splitsetb.enabled:=false;
    splittb.Enabled:=false;

    autob.enabled:=false;
    autose.Enabled:=false;
    soundchb.Enabled:=false;

    caption:=_caption;
  end
  else begin
    Schliessen1.enabled:=true;
    sc.enabled:=true;

    selcutb.Enabled:=(selstart<>selend)and mvok;
    selresetb.Enabled:=((sc.min<>0)or(sc.max<>mp.Length))and mvok;

    splitsetb.enabled:=selcutb.Enabled and mvok;
    splittb.Enabled:=(goplb.Items.count>0)and mvok;

    autob.enabled:=mvok;
    autose.Enabled:=mvok;
    //soundchb.Enabled:=mvok;

    caption:=_caption+' - '+afne.text;
  end;
end;

procedure Thauptf.goplbClick(Sender: TObject);
begin
  setbuttons;
end;

//-----------------------------------------------
function thauptf.sz2str(l:extended):string;
var
  t:int64;
  txt:string;
  dig:integer;
begin
  dig:=2;
  if abs(l)>(1024*1024*1024) then begin
    t:=(1024*1024*1024);
    txt:='GB';
  end
  else if abs(l)>(1024*1024) then begin
    t:=(1024*1024);
    txt:='MB';
  end
  else if abs(l)>1024 then begin
    t:=1024;
    txt:='KB';
  end
  else begin
    t:=1;
    txt:='BT';
    dig:=0;
  end;
  try
    result:=floattostrf(l/t,ffnumber,18,dig)+' '+txt;
  except
    result:='0 '+txt;
  end;
end;

function thauptf.selx2frm(x:integer):integer;
var
  dx,w,i:integer;
  d:double;
begin
  dx:=_pbdx;
  w:=(sc.Width-(2*dx)-14);
  d:=w/(sc.Max-sc.Min);
  x:=x-dx-sc.left;
  i:=trunc(x/d);
  if i<sc.min then i:=sc.min;
  if i>sc.Max then i:=sc.Max;
  result:=i;
end;

//---------------------------------------------------------------------------
function thauptf.getsplittinfo(von,bis:integer):string;
var
 ivon,ibis:integer;
 gvon,gbis:int64;
begin
  ivon:=mcifrm2frm(von);
  ibis:=mcifrm2frm(bis);

  gvon:=frame2gop(ivon,false);gvon:=frmpos[gvon];
  gbis:=frame2gop(ibis,true);gbis:=frmpos[gbis]+getgopsz(gbis);

  result:=
    'Frames: '+inttostr(von)+'-'+inttostr(bis)+' ('+inttostr(bis-von)+') | '+
    'InxFrames: '+inttostr(ivon)+'-'+inttostr(ibis)+' ('+inttostr(ibis-ivon)+') | '+
    'GOP: '+inttostr(gvon)+'-'+inttostr(gbis)+' ('+inttostr(gbis-gvon)+') | '+
    'Dateigrsse: '+sz2str((gbis-gvon)+hdlen+1)+' ('+inttostr((gbis-gvon)+hdlen+1)+' Byte)';
end;

//-------------------------------------------------------------------------
procedure Thauptf.pntbDblClick(Sender: TObject);
var
  s:string;
  c,von,bis:integer;
begin
  if selrow=-1 then exit;
  s:=goplb.items[selrow];
  c:=pos(':',s);
  von:=strtoint(trim(copy(s,1,c-1)));
  bis:=strtoint(trim(copy(s,c+1,length(s))));

  sc.Position:=bis;
  selstart:=von;
  selend:=bis;
  splitwrkok:=true;
  mktbsel;
  selpbPaint(self);

  mkpntb;
  pntbPaint(self);
end;

//-------------------------------------------------------------------------
procedure Thauptf.pntbClick(Sender: TObject);
var
  c,r,i,von,bis:integer;
  s:string;
  p:tpoint;
begin
  splitwrkok:=false;
  getcursorpos(p);
  p:=pntb.ScreenToClient(p);

  //welchen bereich getroffen?
  i:=selx2frm(p.x);

  //markierten bereich getroffn?
  pntb.hint:='';
  selrow:=-1;
  for r:=0 to goplb.items.count-1 do begin
    s:=goplb.items[r];
    c:=pos(':',s);
    von:=strtoint(trim(copy(s,1,c-1)));
    bis:=strtoint(trim(copy(s,c+1,length(s))));

    if(von<=i)and(i<=bis)then begin
      selrow:=r;

      sc.Position:=von;
      s:=
        'Splitt '+inttostr(r+1)+' |'+
        getsplittinfo(von,bis);

      wrstat('-1',s);
      break;
    end;
  end;

  goplb.ItemIndex:=selrow;
  mkpntb;
  pntbPaint(self);

end;

//-----------------------------------------------------------------------
function thauptf.scanframes(fn:string;var gopc:integer):integer;
const
  _bufmax=1024000;
  //_bufmax=100;
  _chksz=50;
var
  fh:thandle;
  cc,c,fc:int64;
  hc,frmc,rd,gopszc:integer;
  buf:array[0.._bufmax+1]of byte;
  b,bb:byte;
  pbc,fbc:integer;
  firstreadok,firstgopok:bool;
  pts,dts:double;
  i:int64;
  status:string;
begin
  screen.cursor:=crhourglass;

  result:=-1;

  mvok:=false;
  status:='';
  pb.Max:=filesz(fn) div _bufmax;
  pb.position:=0;

  fh:=FileOpen(fn,fmOpenRead);
  try

    try
      firstreadok:=true;
      firstgopok:=true;
      gopmaxsz:=0;gopszc:=0;
      frmno:=0;
      pbc:=0;
      fc:=0;
      frmc:=0;
      gopc:=0;
      repeat
        inc(pbc);pb.position:=pbc;
        //if pbc=1500 then beep;
        application.processmessages;
        //sleep(400);

        rd:=fileread(fh,buf,_bufmax);
        if rd=-1 then begin
          status:='FEHLER FileRead';
          break;
        end;

        if firstreadok and(rd>=4)then begin
          //ist's berhaupt ein mpg? magic number

          if not((buf[0]=0)and(buf[1]=0)and(buf[2]=1)and(buf[3]=_PACK_tag))then begin
            status:='MPG-Magic Code fehlt: Kein MPG-File!';
            break;
          end;

          firstreadok:=false;
        end;

        if rd<_chksz then begin
          //regulrer abbruch
          break;
        end;


        c:=0;
        while c<rd-_chksz do begin

          //mpg-tag erwischt?
          if (buf[c]=0)and(buf[c+1]=0)and(buf[c+2]=1)then begin

            b:=buf[c+3];
            if b=_GOP_tag then begin
              //gop-position merken
              frmtyp[frmc]:='G';
              frmpos[frmc]:=fc+c;
              frmnr[frmc]:=-1;
              inc(frmc);
              inc(gopc);

              if firstgopok then begin
                //mpg head wegsichern (fr sptere splittfiles)
                for hc:=0 to c-1 do begin
                  hdbuf[hc]:=buf[hc];
                end;
                hdlen:=c-1;
                firstgopok:=false;
              end;

              if fc+c-gopszc>gopmaxsz then gopmaxsz:=fc+c-gopszc;

              gopszc:=fc+c;

            end


            else if b=_PACK_tag then begin
              frmtyp[frmc]:='C';
              frmpos[frmc]:=fc+c;
              frmnr[frmc]:=-1;
              inc(frmc);
            end


            else if
              (b>=_VSTREAM1_tag)and(b<=_VSTREAM2_tag)or
              (b>=_ASTREAM1_tag)and(b<=_ASTREAM2_tag)
            then begin

              if firstgopok and(b>=_VSTREAM1_tag)and(b<=_VSTREAM2_tag)then begin
                //headerlaengen-position merken, muss pro split adaptiert werden
                hdlenpos:=c;
              end;


              //zu merken, weil timercode?

              //fuellbytes zu berspringen?
              fbc:=Get_fuellbytes(@buf,c+6,_bufmax);

              if fbc>20 then beep;

              //buffer vorhanden? dann pts zwei bytes weiter
              cc:=c+6+fbc;
              b:=buf[cc];b:=byte(b shr 7);
              bb:=buf[cc];bb:=byte(bb shl 1);bb:=byte(bb shr 7);
              if(b=0)and(bb=1)then cc:=cc+2;

              //presentation / decode time stamp
              b:=buf[cc];b:=byte(b shl 2);b:=byte(b shr 7);
              bb:=buf[cc];bb:=byte(bb shl 3);bb:=byte(bb shr 7);
              b:=b*2+bb;


              pts:=-1;dts:=-1;
              if b=0 then begin
                // !PTS !DTS
                frmnr[frmc]:=0;
              end
              else if b=1 then begin
                //pts-fehler
                frmnr[frmc]:=1;
              end
              else if b=2 then begin
                //nur pts
                pts:=get_ts(@buf,cc);
                frmnr[frmc]:=2;
              end
              else if b=3 then begin
                //pts und dts
                pts:=get_ts(@buf,cc);
                dts:=get_ts(@buf,cc+5);
                frmnr[frmc]:=3;
              end;

              if(pts<>-1)or(dts<>-1)then begin
                b:=buf[c+3];
                if(b>=_VSTREAM1_tag)and(b<=_VSTREAM2_tag)then frmtyp[frmc]:='V'
                                                         else frmtyp[frmc]:='A';
                frmpos[frmc]:=fc+cc;
                inc(frmc);
              end;

            end


            else if b=_FRAME_tag then begin
              //gltiges frame erwischt?
              b:=buf[c+5];b:=byte(b shl 2);b:=byte(b shr 5);
              //typ und position merken
              if      b=0 then frmtyp[frmc]:='L'
              else if b=1 then frmtyp[frmc]:='I'
              else if b=2 then frmtyp[frmc]:='P'
              else if b=3 then frmtyp[frmc]:='B'
              else if b=4 then frmtyp[frmc]:='D';
              frmpos[frmc]:=fc+c;
              frmnr[frmc]:=frmno;
              inc(frmc);
              inc(frmno);
            end;
          end;
          inc(c);
        end;


        i:=fileseek(fh,-(_chksz-1),1);
        if i=-1 then begin
          status:='FEHLER FileSeek';
          break;
        end;
        fc:=fc+rd-(_chksz-1);
      until rd=0;

      //enmarker setzen
      frmtyp[frmc]:='G';
      frmpos[frmc]:=filesz(fn);//fc+c;

      //max gop anpassen?
      if frmpos[frmc]-gopszc>gopmaxsz then gopmaxsz:=frmpos[frmc]-gopszc;

      inc(frmc);
      framec:=frmc;
      //result:=frmc-gopc;
      result:=frmc;
    except
      status:='FEHLER ???';
    end;
  finally
    fileclose(fh);

    pb.position:=0;
    screen.cursor:=crdefault;

    if status<>'' then application.MessageBox(pchar(status),'*** FEHLER ***',mb_ok)
                  else mvok:=true;
  end;
end;


//------------------------------------------------------------------------
function thauptf.splittfile(
  fhin:thandle;
  frmvon:integer;
  frmbis:integer;
  fnnach:string
):bool;
const
  _bufc=20;
var
  fhout:thandle;
  //hl,c,
  cc,i,si:int64;
  c,rd,wr:integer;
  pts,dts,
  tsadd,ts,tsdiff,scr:double;
  b:integer;
  gopsz,r:integer;
  hl,tr,nsc:integer;
  packfirstok:bool;
  cpok:bool;
begin
  //result:=false;

  tsadd:=0.26; //0.26
  tsdiff:=0;
  packfirstok:=true;

  //ausgabefile vorbereiten
  fhout:=Filecreate(fnnach);

  try


    //startwert auf gop
    frmvon:=frame2gop(frmvon,false);

    //endwert auf gop
    frmbis:=frame2gop(frmbis,true);


    //gop fr gop einlesen
    for r:=frmvon to frmbis do begin


      //beachte nur gops
      if frmtyp[r]<>'G' then continue;

      //an gop-position
      i:=frmpos[r];
      si:=fileseek(fhin,i,0);
      if si=-1 then begin
        beep;
        break;
      end;

      //gop einlesen
      gopsz:=getgopsz(r);
      rd:=fileread(fhin,gopbufp^,gopsz);
      if rd=-1 then begin
        beep;
        break;
      end;

      //timecodes neu setzen
      tr:=r+1;
      repeat
        if frmtyp[tr]='C' then begin
          //pack

          //position im file
          cc:=frmpos[tr];

          //position im buffer
          cc:=cc-i;

          //scr holen
          scr:=get_ts(gopbufp,cc+4);

          //erstes pack im ersten treffer-gop?
          if packfirstok then begin
            //erstes neue pack, zeitdiff berechnen
            tsdiff:=scr-0.02;


            //headerlen fr ersten vstream berechnen
            hl:=hdlen+cc+1-hdlenpos-6;

            //hl in head schreiben schreiben
            b:=byte(hl div 256);hdbuf[hdlenpos+4]:=b;
            b:=byte(hl mod 256);hdbuf[hdlenpos+5]:=b;

            packfirstok:=false;
          end;

          //neuen scr berechnen
          ts:=scr-tsdiff+tsadd;

          //und zurckschreiben
          put_ts(gopbufp,cc+4,ts);

        end
        else if
          //((frmtyp[tr]='A')and soundchb.Checked)or
          (frmtyp[tr]='A')or
          (frmtyp[tr]='V')
        then begin
          //audio bzw. video-stream

          //position im file
          cc:=frmpos[tr];

          //position im buffer
          cc:=cc-i;

          b:=frmnr[tr];
          pts:=-1;dts:=-1;
          if b=0 then begin
            // !PTS !DTS
          end
          else if b=1 then begin
            //pts-fehler
            beep;
          end
          else if b=2 then begin
            //nur pts
            pts:=get_ts(gopbufp,cc);
          end
          else if b=3 then begin
            //pts und dts
            pts:=get_ts(gopbufp,cc);
            dts:=get_ts(gopbufp,cc+5);
          end;


          //neue pts berechnen?
          if pts>-1 then begin
            ts:=pts-tsdiff+tsadd;
            //s:=s+'PTS:'+ftoa(pts)+'->'+ftoa(ts)+' ';
            put_ts(gopbufp,cc,ts);
          end;

          //dts neue berechnen?
          if dts>-1 then begin
            ts:=dts-tsdiff+tsadd;
            //s:=s+'DTS:'+ftoa(dts)+'->'+ftoa(ts)+' ';
            put_ts(gopbufp,cc+5,ts);
          end;

        end;

        inc(tr);
      until frmtyp[tr]='G';


      //adaptierten header einmal an anfang schreiben
      if r=frmvon then begin
        wr:=filewrite(fhout,hdbuf,hdlen+1);
        if wr=-1 then
          beep;
      end;

      if soundchb.checked then begin
        //jeden adaptierten gop anhngen
        wr:=filewrite(fhout,gopbufp^,rd);
      end
      else begin
        //soundframes rausziehen

        c:=0;nsc:=0;cpok:=false;
        while c<rd-3 do begin

          //mpg-tag erwischt?
          if(gopbufp[c]=#0)and(gopbufp[c+1]=#0)and(gopbufp[c+2]=#1)then begin
            b:=byte(gopbufp[c+3]);
            if b<>_PACK_tag then begin
              cpok:=(b<_ASTREAM1_tag)or(b>_ASTREAM2_tag);
            end;
          end;

          if cpok then begin
            gopnsbufp[nsc]:=gopbufp[c];
            inc(nsc);
          end;

          inc(c);
        end;

        //rest
        if cpok then begin
          gopnsbufp[nsc+1]:=gopbufp[c+1];
          gopnsbufp[nsc+2]:=gopbufp[c+2];
          gopnsbufp[nsc+3]:=gopbufp[c+3];
          nsc:=nsc+3;
        end;

        //copymemory(gopnsbufp,gopbufp,rd);
        wr:=filewrite(fhout,gopnsbufp^,nsc);
      end;

      if wr=-1 then begin
        beep;
      end;

    end;

    result:=true;

  finally
    fileclose(fhout);
  end;
end;


procedure Thauptf.httpwwwdanielschwammde1Click(Sender: TObject);
begin
  ShellExecute(Handle,NIL,PChar('http://www.daniel-schwamm.de'),'',nil,SW_SHOWNORMAL);
end;

end.

